#!/usr/bin/perl

  use FileHandle;
  use Net::SSLeay;
  use Socket;

  Net::SSLeay::load_error_strings();
  Net::SSLeay::SSLeay_add_ssl_algorithms();
  Net::SSLeay::randomize();

  require 'GDUpdate-lib.pl';
  &ReadParse();

  &header("Guardian Digital Update", "");

  ### Get an array of our input keys.
  @vars = keys %in;


  $packages = 0;
  foreach $var (@vars) {
    if ($in{$var} eq "on") {
      $package[$packages]{'name'} = $var;
      $packages++;	
    }
  }

  open (FILE, "< incoming/Updates");
    @lines = <FILE>;
  close (FILE);

  $curpack = -1;
  foreach $line (@lines) {
    $i = 0;
    while ($i <= $packages - 1) {
      if ($line =~ m/^\%/) {
        if ($line =~ m/^\%PACKAGE-INFO-END/) { $curpack = -1 }

        $item = $line;
        if ($item =~ m/^\%([a-z]+)\ (.*)/) {
          $directive = $1;
          $value = $2;
          $directive =~ s/^\$//g;
        }

        if ($directive eq "name") { 
          for ($n = 0; $n <= $packages; $n++) {
            if ($package[$n]{'name'} eq $value) { $curpack = $n; }
          }
        }	          

        if ($curpack >= 0) {
          if ($directive eq "url") {
            $package[$curpack]{'url'} = $value;
          }
          if ($directive eq "version") {
            $package[$curpack]{'version'} = $value;
          }
          if ($directive eq "release") {
            $package[$curpack]{'release'} = $value;
          }
          if ($directive eq "priority") {
            $package[$curpack]{'priority'} = $value;
          }
          if ($directive eq "reboot") {
            $package[$curpack]{'reboot'} = $value;
          }       
          if ($directive eq "filename") {
            $package[$curpack]{'filename'} = $value;
          }
        }

      }

      $i++;
    }
  }

  $i = 0;
  while ($i <= $packages - 1) {
      $packageDownloads .= "<TR $cb>\n";
      $packageDownloads .= "  <TD><DIV CLASS=nbody><B>$package[$i]{'name'}</B>";
      $packageDownloads .= "</DIV></TD>\n";
      $packageDownloads .= "  <TD><DIV CLASS=nbody>$package[$i]{'url'}</TD>\n";
      $packageDownloads .= "  <TD><DIV CLASS=nbody><B>";
      $packageDownloads .= &getReboot ($package[$i]{'reboot'});
      $packageDownloads .= "</B></DIV></TD>\n";
      $packageDownloads .= "</TR>";
    $i++;
  }

  if ($packages == 1) { $plural = "Package"; }
  else { $plural = "Packages"; }

  ### ##########################################################################
  ### Let's go ahead and download the packages. ################################
  ### ##########################################################################
  for ($i = 0; $i < $packages; $i++) {
    my ($dest_serv, $port, $file, $msg);

    $port = 443;
    ($dest_serv,$file) = ($package[$i]{'url'} =~ m/^http\:\/\/([^\/]*)\/(.*)$/);
    $msg  = "GET /$file HTTP/1.1\r\n";
    $msg .= "Host: $dest_serv\r\n\n";

    ($filename) = ($file =~ m/([^\/]+)$/);

    ### Fun stuff.
    $port = getservbyname ($port, 'tcp') unless $port =~ /^\d+$/;
    $dest_ip = gethostbyname ($dest_serv);
    $dest_serv_params  = sockaddr_in($port, $dest_ip);

    ### More fun stuff.
    socket  (SOCK, &AF_INET, &SOCK_STREAM, 0)  or die "socket: $!";
    connect (SOCK, $dest_serv_params)          or die "connect: $!";
    select  (SOCK); $| = 1; select (STDOUT);   # Eliminate STDIO buffering

    ### The network connection is now open, lets fire up SSL
    $ctx = Net::SSLeay::CTX_new();
    Net::SSLeay::CTX_set_options($ctx, &Net::SSLeay::OP_ALL);
    $ssl = Net::SSLeay::new($ctx);
    Net::SSLeay::set_fd($ssl, fileno(SOCK));
    $res = Net::SSLeay::connect($ssl);

    ### Exchange data
    $res = Net::SSLeay::write($ssl, $msg);  
    shutdown SOCK, 1;

    ### Write the RPM to disk.
    open RPM, ">incoming/$filename";

    my $print = 0;	### Do not print the HTTP header.
    while ($got = Net::SSLeay::read($ssl)) {
      if ($print) { print RPM $got; }
      if ($got =~ m/Content-Type\:/) { $print = 1; }

    }

    ### Close the RPM.
    close RPM;

    ### Tear down the SSL connection.
    Net::SSLeay::free ($ssl);
    Net::SSLeay::CTX_free ($ctx);
    close SOCK;

    ### Install then remove the RPM.
    &toggle_lids(0);
      system "/bin/rpm -Uvh --excludedocs --nodeps --force incoming/$filename";
      unlink "incoming/$filename";
    &toggle_lids(1);
  }

  ### Remove the RPM listing.
  #unlink "incoming/Updates";

  print <<DOWNLOAD;
<FORM ACTION="index.cgi" METHOD="POST">
<P><CENTER><TABLE BORDER="0" WIDTH="620" CELLPADDING="0" CELLSPACING="0">
<TR $tb>
  <TD COLSPAN="2"><DIV CLASS="ttitle"><B>
    Downloaded and Installed $packages $plural
  </B></DIV></TD>
</TR>

<TR $cb>
  <TD COLSPAN="2"><DIV CLASS=nbody>
    The following packages were installed
  </DIV></TD>
</TR> 

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD WIDTH="20">&nbsp;</TD>
  <TD>
  <TABLE BORDER=0 WIDTH=100% CELLPADDING=0 CELLSPACING=0>

  <TR $tb>
    <TD><DIV CLASS=thead><B>Package Name</B></DIV></TD>
    <TD><DIV CLASS=thead><B>Package URL</B></DIV></TD>
    <TD><DIV CLASS=thead><B>Reboot</B></DIV></TD>
  </TR>

 $packageDownloads

  <TR $cb><TD COLSPAN=3>&nbsp;</TD></TR>

  <TR $cb>
    <TD ALIGN="RIGHT" COLSPAN="3"><DIV CLASS=nbody>
      <INPUT TYPE="SUBMIT" NAME="DONE" VALUE="Done">
    </DIV></TD>
  </TR>
  </TABLE>
  </TD>
</TR>
</TABLE></CENTER></FORM><P>
DOWNLOAD

  &ryanFooter ("/");


####################################
sub getReboot {

  my($reboot) = @_;

  if ($reboot == 1) { $value = "<FONT COLOR=\"RED\">Yes<\/FONT>"; }
  else { $value = "<FONT COLOR=\"GREEN\">No<\/FONT>"; }

  return $value;
}


sub toggle_lids() {
  my ($func)  =  @_;

  use Crypt::RIPEMD160;

  ### Get the cleartext pass.
  open FILE, "/etc/webtool/SystemManager/config";
    while (<FILE>) { if ($_ =~ m/^pass\=(.*)$/) { $mysql_pass = $1; } }
  close FILE;

  ### Hash it.
  my $old_hash = new Crypt::RIPEMD160;
  $old_hash->add($mysql_pass);
  $digest      = $old_hash->digest();;
  $OLD_PASS    = unpack "H*", $digest;

  ### Turn off LIDS.
  if ($func == 0)    { $out = `/sbin/lidsadm_gd -Q -- -LIDS $OLD_PASS 2>&1`; }
  elsif ($func == 1) { $out = `/sbin/lidsadm_gd -Q -- +LIDS $OLD_PASS 2>&1`; }
}
