#!/usr/bin/perl

  use FileHandle;
  use Net::SSLeay;
  use RPM::Database '%RPM';
  use Socket;

  require 'GDUpdate-lib.pl';
  &ReadParse();

  $packages = 0;

  &header("Guardian Digital Update", "");

  ### Initialize SSL.
  Net::SSLeay::load_error_strings();
  Net::SSLeay::SSLeay_add_ssl_algorithms();
  Net::SSLeay::randomize();

  ### Setup destination server, port, and our message.
  $dest_serv   = "updates.guardiandigital.com";
  $port        = 443;
  $msg         = "GET /Updates HTTP1.1\r\n";
  $msg        .= "Host:  updates.uardiandigital.com\r\n\r\n";

  ### Fun stuff.
  $port = getservbyname ($port, 'tcp') unless $port =~ /^\d+$/;
  $dest_ip = gethostbyname ($dest_serv);
  $dest_serv_params  = sockaddr_in($port, $dest_ip);

  ### More fun stuff.
  socket  (SOCK, &AF_INET, &SOCK_STREAM, 0)  or &err_connect('-5');
  connect (SOCK, $dest_serv_params)          or &err_connect('-6');
  select  (SOCK); $| = 1; select (STDOUT);

  ### Autoflush our filehandles.
  SOCK->autoflush(1);
  STDOUT->autoflush(1);

  ### The socket is now open, lets fire up SSL.
  $ctx = Net::SSLeay::CTX_new();
  Net::SSLeay::CTX_set_options($ctx, &Net::SSLeay::OP_ALL);
  $ssl = Net::SSLeay::new($ctx);
  Net::SSLeay::set_fd($ssl, fileno(SOCK));
  $res = Net::SSLeay::connect($ssl);

  $res = Net::SSLeay::write($ssl, $msg);  # Perl knows how long $msg is

  shutdown SOCK, 1;  # Half close --> No more output, sends EOF to server

  while ($got = Net::SSLeay::read($ssl)) {
    $rpms .= $got;
  }


  ### Write the page to the file.
  open FILE, ">incoming/Updates";
    print FILE $rpms;
  close FILE;

  Net::SSLeay::free ($ssl);               # Tear down connection
  Net::SSLeay::CTX_free ($ctx);

  close SOCK;

print <<HEAD01;
<FORM METHOD="POST" ACTION="download.cgi">
<P><CENTER><TABLE WIDTH="620" CELLSPACING="0" CELLPADDING="1" BORDER="0">
<TR $tb>
  <TD COLSPAN=2><DIV CLASS="ttitle"><B>
    New Packages from Guardian Digital
  </B></DIV></TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

HEAD01

  if (! -s "incoming/Updates") {
    print <<HEADEOF;
<TR $cb>
  <TD WIDTH="20">&nbsp;</TD>
  <TD>
    <TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="0">
    <TR $cb>
      <TD><DIV CLASS="nbody"><B>There was an error contacting the server. 
      Please try again later. (Error Code -10)</DIV></TD>
    </TR>

    <TR $cb><TD>&nbsp;</TD></TR>
    </TABLE>
  </TD>
</TR>
</TABLE></CENTER></FORM><P>
HEADEOF
  }
  else {

    print <<HEAD01;
<TR $cb>
  <TD WIDTH="20">&nbsp;</TD>
  <TD>
    <TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="0">
    <TR $tb>
      <TD><DIV CLASS=thead><B>Package Name</B></DIV></TD>
      <TD><DIV CLASS=thead><B>Description</B></DIV></TD>
      <TD><DIV CLASS=thead><B>Priority&nbsp;</B></DIV></TD>
      <TD><DIV CLASS=thead><B>Reboot&nbsp;</B></DIV></TD>
      <TD><DIV CLASS=thead><B>Download&nbsp;</B></DIV></TD>
    </TR>
HEAD01

    ### Re-read the file.
    open RPMLIST, "incoming/Updates";
    while (<RPMLIST>) {
      chomp $_;

      ### We are starting a new package so let's set IN_RECORD.
      if ($_ =~ m/^%PACKAGE-INFO-START$/)  { $IN_RECORD = 1; $IN_DESCR = 0; }

      ### We are done with this package so let's do the comparison.
      elsif ($_ =~ m/^%PACKAGE-INFO-END$/) {
        $IN_RECORD = 0;

        if ($RPM{$NAME}) {
          my ($name, $version, $release) = $RPM{$NAME}->NVR();
          if (&cmp_rev($release, $UPDATE{'release'})) {
            print "    <TR $cb>\n";
            print "      <TD VALIGN=TOP><DIV CLASS=nbody>$UPDATE{'name'}",
                  "</DIV></TD>\n";
            print "      <TD><DIV CLASS=nbody>$UPDATE{'description'}",
                  "</DIV></TD>\n";
            print "      <TD VALIGN=TOP><DIV CLASS=nbody>$UPDATE{'priority'}",
                  "</DIV></TD>\n";
            print "      <TD VALIGN=TOP><DIV CLASS=nbody>$UPDATE{'reboot'}",
                  "</DIV></TD>\n";
            print "      <TD VALIGN=TOP><DIV CLASS=nbody>",
                "<INPUT TYPE=CHECKBOX NAME=$UPDATE{'name'}></DIV></TD>\n";
                  "</DIV></TD>\n";
            print "    </TR>\n\n";

            print "    <TR $cb><TD COLSPAN=5>&nbsp;</TD></TR>\n\n";
          }
        }
        else {
          print "    <TR $cb>\n";
          print "      <TD VALIGN=TOP><DIV CLASS=nbody>$UPDATE{'name'}",
                "</DIV></TD>\n";
          print "      <TD><DIV CLASS=nbody>$UPDATE{'description'}",
                "</DIV></TD>\n";
          print "      <TD VALIGN=TOP><DIV CLASS=nbody>$UPDATE{'priority'}",
                "</DIV></TD>\n";
          print "      <TD VALIGN=TOP><DIV CLASS=nbody>$UPDATE{'reboot'}",
                "</DIV></TD>\n";
          print "      <TD VALIGN=TOP><DIV CLASS=nbody>",
                "<INPUT TYPE=CHECKBOX NAME=$UPDATE{'name'}></DIV></TD>\n";
          print "    </TR>\n\n";

          print "    <TR $cb><TD COLSPAN=5>&nbsp;</TD></TR>\n\n";

        }        

        undef %UPDATE;
      }
      
      ### We have the name of the package.
      elsif (($IN_RECORD) && ($_ =~ m/^%name\ (.*)$/))
        { $UPDATE{'name'} = $1; $NAME = $1; }
      
      ### We have the url of the package.
      elsif (($IN_RECORD) && ($_ =~ m/^%url\ (.*)$/))
        { $UPDATE{'url'} = $1; }
      
      ### We have the filename of the package.
      elsif (($IN_RECORD) && ($_ =~ m/^%filename\ (.*)$/))
        { $UPDATE{'filename'} = $1; }
      
      ### We have the version of the package.
      elsif (($IN_RECORD) && ($_ =~ m/^%version\ (.*)$/))
        { $UPDATE{'version'} = $1; }
      
      ### We have the release of the package.
      elsif (($IN_RECORD) && ($_ =~ m/^%release\ (.*)$/))
        { $UPDATE{'release'} = $1; }
      
      ### We have the priority of the package.
      elsif (($IN_RECORD) && ($_ =~ m/^%priority\ (.*)$/))
        { $UPDATE{'priority'} = $1; }

      ### We have the reboot flag of the package
      elsif (($IN_RECORD) && ($_ =~ m/^%reboot\ (.*)$/))
        { $UPDATE{'reboot'} = $1; }

      ### We have a description so let's set the read flag.
      elsif (($IN_RECORD) && ($_ =~ m/^%description\ 1$/))
        { $IN_DESCR = 1; }

      elsif ($IN_DESCR && $IN_RECORD)
        { $UPDATE{'description'} .= $_}
    }
    close RPMLIST;

    print <<EOF01;
    <TR> <TD COLSPAN="5">&nbsp;</TD> </TR>

    <TR>
      <TD ALIGN="RIGHT" COLSPAN="5"><DIV CLASS=nbody>
        <INPUT TYPE="HIDDEN" NAME="tPackages" VALUE="$packages">
        <INPUT TYPE="SUBMIT" NAME="button" VALUE="Download RPM(s)">
      </TD>
    </TR>
    </TABLE>
  </TD>
</TR>
</TABLE></CENTER></FORM><P>

EOF01

  }


  ### Good ol' footer.
  &ryanFooter("/");






sub cmp_rev() {
  my ($a, $b)         =  @_;
  my ($a1, $b1, $c1)  =  split /\./, $a;
  my ($x1, $y1, $z1)  =  split /\./, $b;

  if (my $tmp1 = ($x1 <=> $a1))    { return $tmp1; }
  elsif (my $tmp2 = ($y1 <=> $b1)) { return $tmp2; }
  elsif (my $tmp3 = ($z1 <=> $c1)) { return $tmp3; }
  else { return 0; }
}


sub err_connect() {
  my ($err_code)  =  @_;

  print <<CONNERR;
<FORM METHOD="POST" ACTION="download.cgi">
<P><CENTER><TABLE WIDTH="620" CELLSPACING="0" CELLPADDING="1" BORDER="0">
<TR $tb>
  <TD COLSPAN=2><DIV CLASS="ttitle"><B>
    GD Update:  A Connection Occurred
  </B></DIV></TD>
</TR>

<TR $cb><TD COLSPAN=2>&nbsp;</TD></TR>

<TR $cb>
  <TD WIDTH="20">&nbsp;</TD>
  <TD>
    <TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="0">
    <TR $cb>
      <TD><DIV CLASS="nbody"><B>There was an error contacting the server. 
      Please try again later. (Error Code $err_code)</DIV></TD>
    </TR>

    <TR $cb><TD>&nbsp;</TD></TR>
    </TABLE>
  </TD>
</TR>
</TABLE></CENTER></FORM><P>
CONNERR

  &ryanFooter("/");
}
